library("gdata", lib.loc="~/R/win-library/3.1")
library("doBy", lib.loc="~/R/win-library/3.1")
library("ggplot2", lib.loc="~/R/win-library/3.1")
library("chron", lib.loc="~/R/win-library/3.1")
library(stringi)
library("AICcmodavg", lib.loc="~/R/win-library/3.1")
library(MuMIn)
 
  Behave<-read.csv("HatcheryObs.csv")
  Behave$Year<-as.numeric(as.character(Behave$Year))
  Behave$Timing<-as.factor(Behave$Timing)
  Behave$Hatchery<-factor(Behave$Hatchery, levels (Behave$Hatchery)[c(1,5,3,2,4)])
  Behave$ObsTime<-as.numeric(Behave$ObsTime)
  mod1<-glm(Binom_Num_MnHatchery~Hatchery*Timing+Year+ObsTime, family = binomial, data = HatcheryObs)
  dredge(mod1)

  AICc(mod1)
  summary(glm(Binom_Num_MnHatchery~Hatchery+Timing+ObsTime, family = binomial, data = HatcheryObs) )$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery+Timing+Year+ObsTime, family = binomial, data = HatcheryObs) )$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery*Timing+ObsTime, family = binomial, data = HatcheryObs) )$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery*Timing+Year+ObsTime, family = binomial, data = HatcheryObs) )$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery+Timing, family = binomial, data = HatcheryObs) )$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery+Timing+Year, family = binomial, data = HatcheryObs) )$deviance


  mod<-glm(Binom_Num_MnHatchery~Hatchery+Timing+ObsTime, family = binomial, data = HatcheryObs)
  
  Behave.mod<-Behave[!is.na(Behave$Binom_Num_MnHatchery)&
                       !is.na(Behave$Hatchery)&
                       !is.na(Behave$Timing)&
                       !is.na(Behave$ObsTime)&
                       !is.na(Behave$Year)
                     ,]
  r<-nrow(Behave.mod)
  Behave.mod[r+1,]$Hatchery<-"PortArmstrong"
  Behave.mod[r+1,]$Timing<-"DuringRelease"
  Behave.mod[r+1,]$Year<-"2012"
  Behave.mod[r+1,]$DOY<-138
  Behave.mod$ObsTime<-0.010416667
  Behave.mod$Year<-as.numeric(Behave.mod$Year)

r<-nrow(Behave.mod)
Behave.mod[r+1,]$Hatchery<-"LittlePortWalter"
Behave.mod[r+1,]$Timing<-"BeforeRelease"
Behave.mod[r+1,]$Year<-"2010"
Behave.mod[r+1,]$DOY<-138
Behave.mod$ObsTime<-0.010416667
Behave.mod$Year<-as.numeric(Behave.mod$Year)
  
  Behave.mod$ObsTime<-times(Behave.mod$ObsTime)
  
  Behave.mod$Predict<-predict(mod,newdata = Behave.mod)
  Behave.mod$Predict.seHigh<-predict(mod,newdata = Behave.mod)+predict(mod,newdata = Behave.mod, se.fit = TRUE)$se.fit
  Behave.mod$Predict.seLow<- predict(mod,newdata = Behave.mod)-predict(mod,newdata = Behave.mod, se.fit = TRUE)$se.fit
  
  mod.a<-glm(Binom_Num_MnHatchery~Hatchery+A.Release+ObsTime+Year, family = binomial(link = "logit"), data = Behave[Behave$Timing == "AfterRelease",])
  dredge(mod.a)
  mod.a<-step(mod.a)

  summary(glm(Binom_Num_MnHatchery~Hatchery+A.Release+ObsTime, family = binomial(link = "logit"), data = Behave[Behave$Timing == "AfterRelease",]))$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery+A.Release+ObsTime+Year, family = binomial(link = "logit"), data = Behave[Behave$Timing == "AfterRelease",]))$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery+ObsTime+Year, family = binomial(link = "logit"), data = Behave[Behave$Timing == "AfterRelease",]))$deviance
  summary(glm(Binom_Num_MnHatchery~Hatchery+ObsTime, family = binomial(link = "logit"), data = Behave[Behave$Timing == "AfterRelease",]))$deviance
  summary(glm(Binom_Num_MnHatchery~A.Release+ObsTime, family = binomial(link = "logit"), data = Behave[Behave$Timing == "AfterRelease",]))$deviance
  summary(glm(Binom_Num_MnHatchery~A.Release+ObsTime+Year, family = binomial(link = "logit"), data = Behave[Behave$Timing == "AfterRelease",]))$deviance

  Behave.mod[!is.na(Behave.mod$A.Release),]$Predict<-predict(mod.a,newdata = Behave.mod[!is.na(Behave.mod$A.Release),])
  Behave.mod[!is.na(Behave.mod$A.Release),]$Predict.seHigh<-predict(mod.a,newdata = Behave.mod[!is.na(Behave.mod$A.Release),])+predict(mod.a,newdata = Behave.mod[!is.na(Behave.mod$A.Release),],se.fit = TRUE)$se.fit
  Behave.mod[!is.na(Behave.mod$A.Release),]$Predict.seLow<-predict(mod.a,newdata = Behave.mod[!is.na(Behave.mod$A.Release),])-predict(mod.a,newdata = Behave.mod[!is.na(Behave.mod$A.Release),],se.fit = TRUE)$se.fit
  
  
  Releases.Sum<-summaryBy(JulianDateTime ~ Hatchery+Year, FUN = c(min, max), data = Releases)
  Releases.Sum<-Releases.Sum[!is.na(Releases.Sum$JulianDateTime.min), ]
  
  Releases.Sum[Releases.Sum$JulianDateTime.min == Releases.Sum$JulianDateTime.max,]$JulianDateTime.max<-Releases.Sum[Releases.Sum$JulianDateTime.min == Releases.Sum$JulianDateTime.max,]$JulianDateTime.max +1
  
  Behave.mod$Year<-as.numeric(Behave.mod$Year)
  
  ggplot()+ theme_bw()+theme(legend.position = "none",axis.text=element_text(size=20),strip.background = element_blank(),strip.text = element_blank()
                             )+
    geom_point(aes(DOY, Binom_Num_MnHatchery,shape = as.factor(Binom_Num_MnHatchery), size = 4), data = Behave.mod)+
    facet_wrap(~Hatchery*Year,ncol = 6) + geom_line(aes(DOY,1/(1+exp(-Predict))),data = Behave.mod)+scale_y_log10(breaks = c(0,0.01,0.05,0.15,1.0))+theme(strip.text.x = element_blank())+
    geom_rect(data = Releases.Sum, aes(xmin = JulianDateTime.min,xmax = JulianDateTime.max, ymin = 0, ymax = 1), alpha = 0.4)+
    geom_line(aes(DOY, 1/(1+exp(-Predict.seHigh))), data=Behave.mod, lty = 2)+
    geom_line(aes(DOY, 1/(1+exp(-Predict.seLow ))), data=Behave.mod, lty = 2)



#####


summary(as.factor(Behave$Surface))
summary(as.factor(Behave$Tide))
summary(as.factor(Behave$Bubbles))
summary(as.factor(Behave$Sleep))
summary(as.factor(Behave$Breach))
summary(as.factor(Behave$Kelp))
summary(as.factor(Behave$Dock))
summary(as.factor(Behave$Shore))


summary(Behave$BarrierNum)




#########

r<-resid(mod)
acf(resid(mod))
n<-length(r)
cor(r[-1],r[-n])
